var oShell = new ActiveXObject("WScript.Shell");

//var objWMIService = null;
//objWMIService = GetObject("winmgmts:\\\\.\\root\\CIMV2");
//var colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Battery","WQL",48);

var oBatteries, oBatteries2, BatteryInfo, CellInfo;
var PowerStatus = System.Machine.PowerStatus;


function Init()
{
    onTimer();
    setInterval("onTimer()",5000);
//	binfo.innerText="test";
}

function onTimer()
{
	GetPowerStatus();
}


// --------------------------------------------------------------------
// Get the machine power information.
// --------------------------------------------------------------------
function GetPowerStatus()
{
	oBatteries = GetObject("WinMgmts:").InstancesOf ("Win32_Battery");
	oBatteries2 = GetObject("WinMgmts:").InstancesOf ("Win32_PortableBattery");

	BatteryInfo = "";
	CellInfo = "";

	ShowDevices(oBatteries, "Battery", "Name");
	ShowDevices(oBatteries, "Battery", "DeviceID");
	ShowDevices(oBatteries, "Battery", "BatteryStatus");
	ShowDevices(oBatteries, "Battery", "EstimatedRunTime");
	ShowDevices(oBatteries, "Battery", "EstimatedChargeRemaining");
	ShowDevices(oBatteries, "Battery", "FullChargeCapacity");
	ShowDevices(oBatteries, "Battery", "DesignCapacity");
	ShowDevices(oBatteries, "Battery", "DesignVoltage");
	BatteryInfo += "\n";
	ShowDevices(oBatteries2, "Battery2", "Manufacturer");
	ShowDevices(oBatteries2, "Battery2", "Name");
	ShowDevices(oBatteries, "Battery", "Chemistry");
	ShowDevices(oBatteries2, "Battery2", "DesignCapacity");
	ShowDevices(oBatteries2, "Battery2", "DesignVoltage");

	binfo.innerText=BatteryInfo;
	cinfo.innerText=CellInfo;
}

function ShowDevices(instances, className, Name)
{
	var enumInstances = new Enumerator(instances);
	for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
	{
		var oDevice = enumInstances.item();
		var msg = new String();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			msg += prop.Name + ": " + prop.Value + "\n";
			if (prop.Name == Name)
			{
				if (Name == "BatteryStatus" && PowerStatus.isBatteryCharging == true)
				{
					BatteryInfo += prop.Name + ": " + BattStat[prop.Value -1] + " However, the battery is necessarily charging.\n";
				}
				else if (Name == "BatteryStatus")
				{
					BatteryInfo += prop.Name + ": " + BattStat[prop.Value -1] + " However, the battery is not necessarily charging.\n";
				}
				else if (Name == "EstimatedRunTime")
				{
					if(prop.Value == 255) // no battery
					{
						BatteryInfo += prop.Name + ": " + "The battery is missing.\n";
					}
					else if(!System.Machine.PowerStatus.isPowerLineConnected)//running on battery
					{
						var remaining = 0;
						remaining = prop.Value;
						var hRemaining = Math.floor(remaining / 60);
						var mRemaining = remaining % 60;

						if(remaining != 71582788 && remaining != -1)
							BatteryInfo += prop.Name + ": " + hRemaining + ":" + padnumber(mRemaining) + "h" + "\n";
						else
						{
							BatteryInfo += "Running on battery.\n";
						}
					}
					else if(System.Machine.PowerStatus.isBatteryCharging)
					{
						BatteryInfo += prop.Name + ": " + BattStat[5] + "\n"; //Charging
					}
					else
					{
						BatteryInfo += prop.Name + ": " + BattStat[2] + "\n"; //Fully charged
					}
				}
				else if (Name == "EstimatedChargeRemaining")
				{
					if(prop.Value == 255) // no battery
					{
						BatteryInfo += "Battery Remaining" + ": " + "The battery is missing.\n";
					}
					else {
						BatteryInfo += "Battery Remaining" + ": " + prop.Value + "%\n";
					}
				}
				else if (Name == "FullChargeCapacity" && className == "Battery")
				{
					if (prop.Value != null)
					{
						BatteryInfo += prop.Name + ": " + prop.Value + " mWh\n";
					}
					else
					{
						BatteryInfo += prop.Name + ": " + "--" + " mWh\n";
					}
				}
				else if (Name == "DesignCapacity" && className == "Battery")
				{
					if (prop.Value != null)
					{
						BatteryInfo += prop.Name + ": " + prop.Value + " mWh\n";
					}
					else
					{
						BatteryInfo += prop.Name + ": " + "--" + " mWh\n";
					}
				}
				else if (Name == "DesignVoltage" && className == "Battery")
				{
					if (prop.Value != null)
					{
						BatteryInfo += prop.Name + ": " + prop.Value + " mV\n";
					}
					else
					{
						BatteryInfo += prop.Name + ": " + "--" + " mV\n";
					}
				}
				else if (Name == "Name" && className == "Battery")
				{
					BatteryInfo += prop.Name + ": " + prop.Value + "\n";
				}
				else if (Name == "DeviceID")
				{
					BatteryInfo += prop.Name + ": " + prop.Value + "\n";
				}
				else if (Name == "Chemistry")
				{
					CellInfo += prop.Name + ": " + Chem[Validate(oBatteries, oBatteries2, "Chemistry") -1] + "\n";
				}
				else if (Name == "Manufacturer")
				{
					CellInfo += prop.Name + ": " + prop.Value + "\n";
				}
				else if (Name == "Name")
				{
					CellInfo += prop.Name + ": " + prop.Value + "\n";
				}
				else if (Name == "DesignCapacity")
				{
					if (prop.Value != null)
					{
						CellInfo += prop.Name + ": " + prop.Value + " mWh\n";
					}
					else
					{
						CellInfo += prop.Name + ": " + "--" + " mWh\n";
					}
				}
				else if (Name == "DesignVoltage")
				{
					if (prop.Value != null)
					{
						CellInfo += prop.Name + ": " + prop.Value + " mV\n";
					}
					else
					{
						CellInfo += prop.Name + ": " + "--" + " mV\n";
					}
				}
				else
				{
					BatteryInfo += prop.Name + ": " + prop.Value + "\n";
				}
			}
			// same as msg = msg + prop.Name + ": " + prop.Value + "\n";
		}
//		oShell.Popup(msg, 0, className + " Device", 0);
	}
}

function padnumber(num)
{
	if(num < 10)
		return "0"+num;
	else
		return num;
}


function Validate(inst, inst2, eName)
{
	var enumInst = new Enumerator(inst);
	for ( ; !enumInst.atEnd(); enumInst.moveNext() )
	{
		var oDevice = enumInst.item();
		var msg = new String();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			if (prop.Name == eName)
			{
				var val1 = prop.Value;
			}
		}
	}
	enumInst = new Enumerator(inst2);
	for ( ; !enumInst.atEnd(); enumInst.moveNext() )
	{
		var oDevice = enumInst.item();
		var msg = new String();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			if (prop.Name == eName)
			{
				var val2 = prop.Value;
			}
		}
	}
	if (val1 == val2)
	{
		return val1;
	}
	else
	{
		return val2;
	}

}

