//var oShell = new ActiveXObject("WScript.Shell");
var oCPU = GetObject("WinMgmts:").InstancesOf ("Win32_Processor");
//var oCPU = GetObject("WinMgmts:").InstancesOf ("CIM_Processor");

var cpuInfo = "";

function Init()
{
	GetCPUStatus();
}

// --------------------------------------------------------------------
// Get the machine cpu information.
// --------------------------------------------------------------------
function GetCPUStatus()
{
	ShowDevices(oCPU, "CPU", "Manufacturer");
	ShowDevices(oCPU, "CPU", "Name");
	ShowDevices(oCPU, "CPU", "Family");
	ShowDevices(oCPU, "CPU", "MaxClockSpeed");
	ShowDevices(oCPU, "CPU", "CurrentClockSpeed");
	ShowDevices(oCPU, "CPU", "ExtClock");
	ShowDevices(oCPU, "CPU", "NumberOfCores");
	ShowDevices(oCPU, "CPU", "NumberOfLogicalProcessors");
	ShowDevices(oCPU, "CPU", "L2CacheSize");
	ShowDevices(oCPU, "CPU", "L2CacheSpeed");
	ShowDevices(oCPU, "CPU", "AddressWidth");
	ShowDevices(oCPU, "CPU", "DataWidth");
	ShowDevices(oCPU, "CPU", "Architecture");
	ShowDevices(oCPU, "CPU", "VoltageCaps");
	ShowDevices(oCPU, "CPU", "SocketDesignation");
	ShowDevices(oCPU, "CPU", "UpgradeMethod");

	document.getElementById('cinfo').innerText=cpuInfo;
}

function ShowDevices(instances, className, Name)
{
	var enumInstances = new Enumerator(instances);
	for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
	{
		var oDevice = enumInstances.item();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			if (prop.Name == Name)
			{
				if (Name == "Manufacturer")
				{
					cpuInfo += prop.Name + ": " + prop.Value + "\n";
				}
				else if (Name == "Name" && className == "CPU")
				{
					cpuInfo += prop.Name + ": " + prop.Value + "\n";
				}
				else if (Name == "Family")
				{
					cpuInfo += prop.Name + ": " + Fam[prop.Value] + "\n";
				}
				else if (Name == "MaxClockSpeed")
				{
					cpuInfo += prop.Name + ": " + prop.Value + "MHz\n";
				}
				else if (Name == "CurrentClockSpeed")
				{
					cpuInfo += prop.Name + ": " + prop.Value + "MHz\n";
				}
				else if (Name == "ExtClock")
				{
					if (prop.Value != null)
					{
						cpuInfo += prop.Name + ": " + prop.Value + "MHz\n";
					}
					else
					{
						cpuInfo += prop.Name + ": " + "-- " + "MHz\n";
					}
				}
				else if (Name == "NumberOfCores")
				{
					cpuInfo += prop.Name + ": " + prop.Value + "\n";
				}
				else if (Name == "NumberOfLogicalProcessors")
				{
					cpuInfo += prop.Name + ": " + prop.Value + "\n";
				}
				else if (Name == "L2CacheSize")
				{
					if (prop.Value != null)
					{
						cpuInfo += prop.Name + ": " + prop.Value + "kb\n";
					}
					else
					{
						cpuInfo += prop.Name + ": " + "-- " + "kb\n";
					}
				}
				else if (Name == "L2CacheSpeed")
				{
					if (prop.Value != null)
					{
						cpuInfo += prop.Name + ": " + prop.Value + "MHz\n";
					}
					else
					{
						cpuInfo += prop.Name + ": " + "-- " + "MHz\n";
					}
				}
				else if (Name == "AddressWidth")
				{
					cpuInfo += prop.Name + ": " + prop.Value + " bit\n";
				}
				else if (Name == "DataWidth")
				{
					cpuInfo += prop.Name + ": " + prop.Value + " bit\n";
				}
				else if (Name == "Architecture")
				{
					cpuInfo += prop.Name + ": " + Arch[prop.Value] + "\n";
				}
				else if (Name == "VoltageCaps")
				{
					if (prop.Value != null)
					{
						cpuInfo += prop.Name + ": " + Volt[prop.Value] + "Volts\n";
					}
					else
					{
						cpuInfo += prop.Name + ": " + "-- " + "Volts\n";
					}
				}
				else if (Name == "SocketDesignation")
				{
					cpuInfo += prop.Name + ": " + prop.Value + "\n";
				}
				else if (Name == "UpgradeMethod")
				{
					if (prop.Value != null)
					{
						cpuInfo += prop.Name + ": " + UpgM[prop.Value] + "\n";
					}
					else
					{
						cpuInfo += prop.Name + ": " + "-- " + "\n";
					}
				}
			}
		}
//		oShell.Popup(msg, 0, className + " Device", 0);
	}
}


