var wireless = System.Network.Wireless;
var status;

var objWMIService = null;

function Init()
{
    onTimer();
    setInterval("onTimer()",1000);
}

function onTimer()
{
	networkDetails();
}


//Checking network details
function networkDetails()
{
	var ssid = wireless.ssid;
	var Strength = wireless.signalStrength;
	var ip = wireless.address;
	var primaryDNS = wireless.primaryDNSAddress;
	var security = wireless.secureConnection;
	var dns = wireless.primaryDNSAddress;
	var StrengthdbM;

	var WMI = GetObject("winmgmts:\\\\.\\root\\CIMV2");
//	var oWLAN = GetObject("WinMgmts:").InstancesOf ("MSNdis_80211_ReceivedSignalStrength");
//	var oWLAN = WMI.ExecQuery("SELECT * FROM MSNdis_80211_ReceivedSignalStrength","WQL",48);
	var oWLAN = WMI.ExecQuery("SELECT Ndis80211ReceivedSignalStrength FROM MSNdis_80211_ReceivedSignalStrength","WQL",48);
	var enumInstances = new Enumerator(oWLAN);
	for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
	{
		var oDevice = enumInstances.item();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			if (prop.Name == "Ndis80211ReceivedSignalStrength")
			{
				StrengthdbM = prop.Value;
			}
			else
			{
				StrengthdbM = "-- ";
			}
		}
	}

	//If connected display, the network information, if there's an SSID then you are connected
	if (ssid != "")
	{
		status = true;
		document.getElementById('networkDetailsStatus').innerText = "Status: Connected";
		document.getElementById('networkDetailsssid').innerText = "SSID: " + ssid;
		if (StrengthdbM)
		{
			document.getElementById('networkDetailsSignaldbM').innerText = "Signalstrength: " + StrengthdbM + "dbM";
		}
		else
		{
			document.getElementById('networkDetailsSignaldbM').innerText = "Signalstrength: -- " + "dbM";
		}
		document.getElementById('networkDetailsSignalPercent').innerText = "Signalquality: " + Strength + "%";
		document.getElementById('networkDetailsAddress').innerText = "Internal IP: " + wireless.address;
		if(security == true)
		{
			document.getElementById('networkDetailsSecurity').innerText = "Secured: Yes"
		}
		else
		{
			document.getElementById('networkDetailsSecurity').innerText = "Secured: No"
		}
		document.getElementById('networkDetailsDns').innerText = "Administrate " + ssid;

	}
	//If not connected, then display the filler
	else
	{
		status = false;
		document.getElementById('networkDetailsStatus').innerText = "Status: Disconnected";
		document.getElementById('networkDetailsssid').innerText = "SSID: --";
		document.getElementById('networkDetailsSignaldbM').innerText = "Signalstrength: --";
		document.getElementById('networkDetailsSignalPercent').innerText = "Signalquality: --";
		document.getElementById('networkDetailsAddress').innerText = "Internal IP: --";
		document.getElementById('networkDetailsSecurity').innerText = "Secured: --"
		document.getElementById('networkDetailsDns').innerText = "Connect to a WLAN";
	}

//	document.getElementById('networkDetailsDns').innerText = "Administrate " + ssid;

	if (status == true)
	{
		if (Strength > 79)
		{
			document.getElementById('networkDetailsQuality').innerText = "Quality: Excellent";
		}
		else if (Strength > 59)
		{
			document.getElementById('networkDetailsQuality').innerText = "Quality: Very Good";
		}
		else if (Strength > 39)
		{
			document.getElementById('networkDetailsQuality').innerText = "Quality: Good";
		}
		else if (Strength > 19)
		{
			document.getElementById('networkDetailsQuality').innerText = "Quality: Low";
		}
		else if (Strength > 0)
		{
			document.getElementById('networkDetailsQuality').innerText = "Quality: Very Low";
		}
		else
		{
			document.getElementById('networkDetailsQuality').innerText = "Quality: Out of Range";
		}
	}
	else
	{
		document.getElementById('networkDetailsQuality').innerText = "Quality: --";
	}
}

//Getting the Device IPv4 DNS Address
function getDns()
{
	var ssid = wireless.ssid;
	if (ssid != "")
	{
		System.Shell.execute('http://' + wireless.primaryDNSAddress);
	}
	else
	{
		System.Shell.execute("::{20d04fe0-3aea-1069-a2d8-08002b30309d}\\::{21ec2020-3aea-1069-a2dd-08002b30309d}\\::{38A98528-6CBF-4CA9-8DC0-B1E1D10F7B1B}");
	}
}
